=== Makefile ===

TOPDIR=.

include $(TOPDIR)/cfg/Makefile.glo
