=== common/device/irda/Makefile ===

TOPDIR=../../..

include $(TOPDIR)/cfg/Makefile.glo
