=== common/phone/nokia/dct4s40/Makefile ===

TOPDIR=../../../..

include $(TOPDIR)/cfg/Makefile.glo
