=== cfg/debian/rules ===
#!/usr/bin/make -f
# Gammu rules file by Michal Čihař <michal@cihar.com>
#
# Based on
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

DEBVER=$(shell head -1 debian/changelog.main | tr -d \n | cut -d\( -f2|cut -d \) -f1)
OLDVER=$(shell echo $(DEBVER) | cut -d- -f1)
OLDREL=$(shell echo $(DEBVER) | cut -d- -f2)
VER=$(shell sed -e 's!,!.!g' VERSION)
ifeq (mainstream,$(findstring mainstream,$(DEB_BUILD_OPTIONS)))
	REL=$(OLDREL)
else
	ifeq ($(OLDVER),$(VER))
		REL=$(OLDREL).0
	else
		REL=0.0
	endif
endif

configure-stamp:
	dh_testdir
	./configure \
		CFLAGS=$(CFLAGS) \
		--prefix=/usr \
		--includedir=\$${prefix}/include \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--with-docdir=\$${prefix}/share/doc/gammu \
		--with-localedir=\$${prefix}/share/gammu \
		--enable-cb
	touch configure-stamp


build: build-stamp

build-stamp:  debian/changelog configure-stamp
	dh_testdir

	$(MAKE) shared

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -f debian/changelog
	rm -f configure-stamp
	-$(MAKE) clean


	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -A
	$(MAKE) installshared DESTDIR=$(CURDIR)/debian/tmp


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_installinfo
	dh_installdocs
	dh_installchangelogs ChangeLog
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_movefiles
	for name in gammu libgammu1 libgammu1-dev ; do install -m644 debian/bug.control debian/$$name/usr/share/bug/$$name/control ; done
	dh_makeshlibs -V 'libgammu1 (= $(VER)-$(REL))'
	dh_shlibdeps -L libgammu1 -l debian/libgammu1/usr/lib
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

debian/changelog:
ifeq (mainstream,$(findstring mainstream,$(DEB_BUILD_OPTIONS)))
	cp debian/changelog.main debian/changelog
else
	echo "gammu ("$(VER)-$(REL)") unstable;  urgency=low" > debian/changelog
	echo >> debian/changelog
	echo "  * Locally built." >> debian/changelog
	echo >> debian/changelog
	echo " -- $${DEBFULLNAME:-Unconfigured} <$${DEBEMAIL:-unknown@email}>  $(shell date --rfc-822)" >> debian/changelog
	echo >> debian/changelog
	cat debian/changelog.main >> debian/changelog
endif
